/**
 *  -----------------------------------------------------------------------------
 *  
 *  Holo-Edit, spatial sound trajectories editor, part of Holophon
 *  Copyright (C) 2006 GMEM
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
 *  
 *  -----------------------------------------------------------------------------
 */
package holoedit.opengl;

import java.awt.Color;
import javax.media.opengl.GL;

public class OpenGLUt
{
	public static void glColor(GL gl, float[] color)
	{
		gl.glColor4fv(color, 0);
	}

	public static float[] glColor(GL gl, Color c)
	{
		float[] tmp = new float[4];
		tmp[0] = (float) c.getRed() / 255;
		tmp[1] = (float) c.getGreen() / 255;
		tmp[2] = (float) c.getBlue() / 255;
		tmp[3] = 1;
		
		gl.glColor4fv(tmp,0);
		return tmp;
	}

	public static void drawPoint(GL gl, float x, float y)
	{
		gl.glVertex2f(x, y);
	}

	public static void drawPoint(GL gl, float x, float y, float z)
	{
		gl.glVertex3f(x, y, z);
	}

	public static float[] convCol(Color c)
	{
		return new float[] { (float)c.getRed() / 255, (float)c.getGreen() / 255, (float)c.getBlue() / 255, (float)c.getAlpha() / 255 };
	}

}
